module DockerNginxProxy
  class Nginx

    def install_proxy(name, mapping)
      content = generate_proxy_config(mapping)
      path = '/etc/nginx/sites-available/' + name
      puts " create #{path}"
      File.write(path, content)
      exec('service nginx restart')
    end

    def generate_proxy_config(mapping)
      content = ''
      mapping.each do |domain_port, docker_port|
        domain, port = domain_port.split(':')
        port ||= 80
        content += generate_proxy_config_block(domain, port, docker_port)
      end
      content
    end

    def generate_proxy_config_block(domain, port, docker_port)
      content = <<EOD
server {
  listen {{port}};
  server_name {{server_name}};

  location / {
    proxy_pass localhost:{{target_port}};
  }
}
EOD
      Mustache.render(content, :port => port, :server_name => domain, :target_port => docker_port)
    end
  end
end
